#!/bin/sh

# TEST: Branches: b0
# TEST:  add b1 before b0
# TEST:  add b1 after b0

source scaffold

function files {
cat <<FILES
d /n/lower
d /n/lower/b0
d /n/lower/b1
FILES
}

function beforefiles {
cat <<FILES
f /n/lower/b0/a
f /n/lower/b1/a
FILES
}

function afterfiles {
	beforefiles
}

( files ; beforefiles) | create_hierarchy

mount_union "" /n/lower/b0

checktype $MOUNTPOINT/a 'f'
echo "/n/lower/b0/a" |diff /mnt/unionfs/a -
unionctl /mnt/unionfs --add --before /n/lower/b0 /n/lower/b1
echo "/n/lower/b1/a" |diff /mnt/unionfs/a -

unmount_union

( files ; afterfiles )  | check_hierarchy /n/lower

( files ; beforefiles) | create_hierarchy

mount_union "" /n/lower/b0

checktype $MOUNTPOINT/a 'f'
echo "/n/lower/b0/a" |diff /mnt/unionfs/a -
unionctl /mnt/unionfs --add --after /n/lower/b0 /n/lower/b1
echo "/n/lower/b0/a" |diff /mnt/unionfs/a -

unmount_union

( files ; afterfiles )  | check_hierarchy /n/lower

echo "OK"
exit 0
